﻿# TE-SYSTEMS GmbH
# Script date: May 2025

# This script performs the following actions:
#
#   - Updating the certificate in the selected node 

# In order to use the script, some variables must be adjusted.
#
#	- The path to the REST API PowerShell-Module must be set.
#		By default, the Powershell-Modul is in the folder directly above the one in which this script is located.
#	- The address of  anynode must be set.
#		By default the address is set to localhost.

# Please check all existing parameters before starting the script.

# Set execution environment
Set-ExecutionPolicy -ExecutionPolicy Unrestricted -Scope Process

#---- Variables ----
# The path to the REST API PowerShell-Module must be specified.
# In this case it is in the folder above the one where this script is located.
Import-Module "./../anynode_rest_api_powershell.psm1"

# Define anynode's Address and Port.
$AnynodeAddress='127.0.0.1'
$AnynodePort=443

# Define the ID of the Node, the Certificate should be set to.
$NodeName='NODE_NAME'

# The Path to the certificate file must be specified.
$FilePath="PATH_TO_CERTIFICATE"

# Define the Password of the certificate if present.
$CertPW=''

# If you have not established a secure connection (HTTPS) to anynode,
# you can use HTTP instead.
# This is not recommended, since your data will NOT be encrypted!
# To activate it anyway, uncomment the following line:
# Disable-CertificateCheck

# Authentication
$Cred=Get-Credential

# ----------- Start of script -----------

#Retrieving the ID of the node by node name.
$NodeId=(Get-anynodeNodes -Address $AnynodeAddress -Port $AnynodePort -Credential $Cred |  ? 'displayName' -Like $NodeName).id

#Set's the given Certificate to the selected Node
Set-anynodeNodeCertificate -Address $AnynodeAddress -Port $AnynodePort -Credential $Cred -Mode CERTIFICATES_AND_PRIVATE_KEY -Node $NodeId -CertificateFilePath $FilePath -CertificatePassword $CertPW
